import javax.swing.JLabel;
import java.awt.geom.*;
import java.awt.event.*;
import java.awt.image.*; 
import java.awt.*;
import java.util.*;
import org.jdom.*;

public class ArcLabel extends PetriLabel implements MouseListener, MouseMotionListener{
	int textspace = 15;
	int centresize = 5;
	Element source, target;
	LineLabel srcline, trgline;


    public ArcLabel(Element e) {
		super(e);
		// set up member variables
		offset = 2;
		preferredSize = new Dimension(offset,offset);
		// do custom initialisation
		int x = scaling * Integer.parseInt(element.getChild("graphics",ns).getChild("position",ns).getAttributeValue("x"));
		int y = scaling * Integer.parseInt(element.getChild("graphics",ns).getChild("position",ns).getAttributeValue("y"));
		setBounds(x,y,offset*2+centresize,offset*2+centresize+textspace);
      	addMouseMotionListener(this);
      	addMouseListener(this);

    }

    public void paintComponent(Graphics g){
        	super.paintComponent(g);


        	Graphics2D g2 = (Graphics2D)g;
	  	g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
       	// Draws the centre point of the arc.
	  	g2.setStroke(new BasicStroke(1.0f));
	  	g2.draw(new Rectangle2D.Double(offset, offset, centresize, centresize));

	  	// Draws the arc weight
	  	String weight = element.getChild("inscription",ns).getChild("value",ns).getText();
	  	g2.drawString(weight,offset,centresize+offset*2+textspace);
		
		// draw the lines to source and target
		updateLines();
	
    }

	public void dofirst() {
		super.dofirst();
		srcline = new LineLabel(source,element);
		trgline = new LineLabel(element,target);
		getParent().add(srcline);
		getParent().add(trgline);
	//	getParent().repaint();
		updateLines();
	}

	public void updateLines(){
		srcline.updateLine();
		trgline.updateLine();
	}
	public void repaintLines(){
		srcline.repaint();
		trgline.repaint();
	}

    // Handles the event of a user releasing the mouse button.
    public void mouseReleased(MouseEvent e){
	super.mouseReleased(e);
     updateLines();
     repaintLines();
    }

	public void findAttachedElements(){
		attacheds.clear();

		boolean foundSource=false;
		boolean foundTarget=false;
		String sourceid = element.getAttributeValue("source");
		String targetid = element.getAttributeValue("target");

		Element net = element.getParent();
		java.util.List places = net.getChildren("place",ns);
		Iterator ps= places.iterator();
		while (ps.hasNext() && !foundSource && !foundTarget) {
			Element p = (Element) ps.next();
			if (p.getAttributeValue("id").compareTo(sourceid) ==0 ) {
				foundSource = true;
				source = p;
				attacheds.add(p);
			} else if (p.getAttributeValue("id").compareTo(targetid) ==0 ) {
				foundTarget = true;
				target = p;
				attacheds.add(p);
			}
		}

		java.util.List trans = net.getChildren("transition",ns);
		Iterator ts= trans.iterator();
		while (ts.hasNext() && (!foundSource || !foundTarget)) {
			Element t = (Element) ts.next();
			if (!foundSource && t.getAttributeValue("id").compareTo(sourceid) == 0) {
				foundSource = true;
				source = t;
				attacheds.add(t);
			} else if (!foundTarget && t.getAttributeValue("id").compareTo(targetid) == 0) {
				foundTarget = true;
				target = t;
				attacheds.add(t);
			}
		}

	}
}

