import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.util.*;
import org.jdom.*;
import org.jdom.output.*;

public class DisplayPane extends JPanel {
	Document doc;
    	Dimension preferredSize = new Dimension(500,500);


    public DisplayPane(Document doc){
		setLayout(null);
		this.doc = doc;
		//---save button---//
		JButton bsave = new JButton("Save");
		add(bsave);
		bsave.setBounds(0,0,80,30);
		bsave.addActionListener(new ActionListener() {
			public final void actionPerformed(ActionEvent e) {
				 save();
			}
		});
		//---add places---//
		makeLabels();
    }

    public void makeLabels() {
	      Element root = doc.getRootElement();
		Namespace ns = root.getNamespace();
		Element net = root.getChild("net",ns);
		
		java.util.List places = net.getChildren("place",ns);
		Iterator ps= places.iterator();
		while (ps.hasNext()) {
			Element p = (Element) ps.next();
			// namespace check?
			add(new PlaceLabel(p)); 
		}
		java.util.List transitions = net.getChildren("transition",ns);
		Iterator ts= transitions.iterator();
		while (ts.hasNext()) {
			Element t = (Element) ts.next();
			// namespace check?
			add(new TransitionLabel(t)); 
		}
		java.util.List arcs = net.getChildren("arc",ns);
		Iterator as= arcs.iterator();
		while (as.hasNext()) {
			Element a = (Element) as.next();
			// namespace check?
			add(new ArcLabel(a)); 
		}
    }

    public void save() {
	XMLOutputter xmlout = new XMLOutputter();
	try {
		xmlout.output(doc,System.out); // outputs to console
	} catch (Exception e) { }
	
    }

    public Dimension getPreferredSize() {
        return preferredSize;
    }

    public void paintComponent(Graphics g){
        super.paintComponent(g);
	 paintComponents(g);
	
    }
}

