import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;

public class EditorFrame extends JInternalFrame {
	Document doc;
    static int openFrameCount = 0;
    static final int xOffset = 30, yOffset = 30;

    public EditorFrame() {
        super("Document #" + (++openFrameCount), 
              true, //resizable
              true, //closable
              true, //maximizable
              true);//iconifiable

	  // load in the document
	  loadDocument(new File("net.xml"));

        //...Create the GUI and put it in the window...
	  DisplayPane display = new DisplayPane(doc);
       Container contentPane = getContentPane();
	  contentPane.add(display);

        //...Then set the window size or call pack...
        setSize(700,700);

        //Set the window's location.
        setLocation(xOffset*openFrameCount, yOffset*openFrameCount);

	   // Set the window's title, from the name of the Petri net loaded
         Element root = doc.getRootElement();
	   Namespace ns = root.getNamespace();
	   String title = root.getChild("net",ns).getChild("name",ns).getChild("value",ns).getText();
	   if (title.length()>0)
		   setTitle("Petri Net: "+title);
    }

	public void loadDocument(File f) {
     		 // Request document building without validation
		SAXBuilder builder = new SAXBuilder(false);

		try {
	       	doc = builder.build(f);
		/* Example code for accessing the JDOM elements 
			System.out.print("got the xml\n");
	      	Element root = doc.getRootElement();
			Namespace ns = root.getNamespace();
			Element net = root.getChild("net",ns);

			java.util.List contents = net.getChildren("place",ns);
			Iterator cs= contents.iterator();
			while (cs.hasNext()) {
				Element c = (Element) cs.next();
				System.out.print("found element "+c.getName()+ " id: "+
							c.getAttributeValue("id")+ "\n");
			}
		*/		     	
		} catch (Exception e) { System.out.print("haven't got the xml!\n");}
	}

}
