import javax.swing.JLabel;
import java.awt.geom.*;
import java.awt.event.*;
import java.awt.image.*; 
import java.awt.*;
import java.util.*;
import org.jdom.*;

public class LineLabel extends JLabel {
	int sx,sy,tx,ty;
	int xmin,xmax,ymin,ymax; // bounds
	Element source, target;
	Namespace ns;

    public LineLabel(Element s, Element t) {
		super();
		source = s;
		target = t;
		ns = source.getNamespace();
		updateLine();
		calcBounds();
    }

    public void paintComponent(Graphics g){
        	super.paintComponent(g);
        	Graphics2D g2 = (Graphics2D)g;
	  	g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		Line2D line = new Line2D.Double(sx-getX(), sy-getY(), tx-getX(), ty-getY());
	  	g2.setStroke(new BasicStroke(1.5f));
		g2.draw(line);
		calcBounds();
    }

	public void updateLine() {
		sx = Integer.parseInt(source.getChild("graphics",ns).getChild("position",ns).getAttributeValue("x"));
		sy = Integer.parseInt(source.getChild("graphics",ns).getChild("position",ns).getAttributeValue("y"));
		tx = Integer.parseInt(target.getChild("graphics",ns).getChild("position",ns).getAttributeValue("x"));
		ty = Integer.parseInt(target.getChild("graphics",ns).getChild("position",ns).getAttributeValue("y"));
	}
	
	public void calcBounds() {
		if (sx<tx) {
			xmin = sx;
			xmax = tx;
		} else {
			xmin = tx;
			xmax = sx;
		}
		if (sy<ty) {
			ymin = sy;
			ymax = ty;
		} else {
			ymin = ty;
			ymax = sy;
		}

		setBounds(xmin,ymin,xmax,ymax);

	}

}

