import javax.swing.*;
import java.awt.geom.*;
import java.awt.event.*;
import java.awt.image.*; 
import java.awt.*;
import java.util.*;
import org.jdom.*;

public class PetriLabel extends JLabel implements MouseListener, MouseMotionListener{
	Element element;
	java.util.List attacheds = new java.util.LinkedList(); // list to store attached Elements 
	Namespace ns; // namespace of document
      Dimension preferredSize = new Dimension(40,40);
	boolean beingMoved=false;
	int lastX, lastY;
	int offset = 0;
	int xoffset = 0;
	int yoffset = 0;
	int rotation = 0; // rotation in degrees
	int scaling = 1;
	boolean firsttime=true;
	String id;

    public PetriLabel(Element element) {
	super("");
	setHorizontalAlignment(CENTER);
	this.element = element;
	ns = element.getNamespace();
	int x = scaling * Integer.parseInt(element.getChild("graphics",ns).getChild("position",ns).getAttributeValue("x"));
	int y = scaling * Integer.parseInt(element.getChild("graphics",ns).getChild("position",ns).getAttributeValue("y"));
	id = element.getAttributeValue("id");
	setBounds(x,y,40,40);
      addMouseMotionListener(this);
      addMouseListener(this);
    }

    public void paintComponent(Graphics g){
        super.paintComponent(g);
	 if (firsttime) {
		dofirst();
	 }
	
    }


    public Dimension getPreferredSize() {
        return preferredSize;
    }

	public void dofirst() {
		findAttachedElements();
		firsttime=false;
	}

	// function to help with debugging
	public void examineElement(Element e) {
		System.out.print("Examining element...\n");
		Namespace ns = e.getNamespace();
		java.util.List contents = e.getChildren();
		Iterator es= contents.iterator();
		while (es.hasNext()) {
			Element c = (Element) es.next();
			System.out.print("found element "+c.getName()+ " with namespace "+
							c.getNamespace().toString()+ "\n");
		}

	}


    // Handles the event of a user dragging the mouse while holding
    // down the mouse button.
    public void mouseDragged(MouseEvent e){
            if ( beingMoved ) {
	//	updateLocation(e); // does nasty flickering
		}
    }

    // Handles the event of the user pressing down the mouse button.
    public void mousePressed(MouseEvent e){
	  if (e.isPopupTrigger()) {
		showContextMenu(e);
	  } else if (e.getID()==MouseEvent.MOUSE_CLICKED) {
		mouseClicked(e);
	  } else if (e.getID()==MouseEvent.MOUSE_PRESSED) {
		beingMoved=true;
		lastX = getX() - e.getX();
		lastY = getY() - e.getY();
		updateLocation(e);
	  }
    }

    // Handles the event of a user releasing the mouse button.
    public void mouseReleased(MouseEvent e){
            if ( beingMoved ) {
		 	updateLocation(e);
			// Update DOM with new values
			if (element.getChildren("graphics",ns).size()>0   /* avoid NULL exceptions */
				&& element.getChild("graphics",ns).getChildren("position",ns).size()>0 ) { 
				element.getChild("graphics",ns).getChild("position",ns).setAttribute("x",String.valueOf((getX()+xoffset)/scaling));
				element.getChild("graphics",ns).getChild("position",ns).setAttribute("y",String.valueOf((getY()+yoffset)/scaling));
			}	
			getParent().repaint(); //update the display
			beingMoved=false;
		}
    }

	// test implementation: detects different types of clicks
     public void mouseClicked(MouseEvent e){
	   if (e.getClickCount()==1) {
		if ( (e.getModifiers() & InputEvent.BUTTON1_MASK) == InputEvent.BUTTON1_MASK) { 
			// left button clicked
		} else if ( (e.getModifiers() & InputEvent.BUTTON2_MASK) == InputEvent.BUTTON2_MASK) {
			// middle button clicked
		} else if ( (e.getModifiers() & InputEvent.BUTTON3_MASK) == InputEvent.BUTTON3_MASK) {
			// middle button clicked
			showContextMenu(e);
		}
	   } else if (e.getClickCount()==2) {
		rotation += 45;
		repaint();
	   }
	}

	public void showContextMenu(MouseEvent e) {
		PetriContextMenu popup; 
		popup = new PetriContextMenu(this);
   		popup.show(this, e.getX(), e.getY());
	}
       
     // This method is required by MouseListener.
     public void mouseMoved(MouseEvent e){}

     // These methods are required by MouseMotionListener.
     public void mouseExited(MouseEvent e){}
     public void mouseEntered(MouseEvent e){}
                         
     // Updates the coordinates representing the location of the current rectangle.
     public void updateLocation(MouseEvent e){
            setLocation(lastX + e.getX(), lastY + e.getY());
	     repaint();
     }


     // builds list of attached elements
	public void findAttachedElements(){
		attacheds.clear();
		Element net = element.getParent();
		java.util.List elements = net.getChildren();
		Iterator es= elements.iterator();

		while (es.hasNext()) {
			Element e = (Element) es.next();
			if (e.getAttributeValue("source")!=null && e.getAttributeValue("target")!=null) {
				if (e.getAttributeValue("source").compareTo(id) ==0  || e.getAttributeValue("target").compareTo(id) ==0) {
					attacheds.add(e);
				} 
			}
		}

	}
     
}

