import javax.swing.JLabel;
import java.awt.geom.*;
import java.awt.event.*;
import java.awt.image.*; 
import java.awt.*;
import java.util.*;
import org.jdom.*;

public class PlaceLabel extends PetriLabel implements MouseListener, MouseMotionListener{
	int radius = 20;
	int textspace = 12;

    public PlaceLabel(Element e) {
	super(e);
	// set up member variables
	offset = 4;
	xoffset = radius + offset;
	yoffset = radius + offset;
	preferredSize = new Dimension(2*(radius+offset),2*(radius+offset));
	// do custom initialisation
	setText(element.getChild("initialMarking",ns).getChild("value",ns).getText());
	int x = scaling * Integer.parseInt(element.getChild("graphics",ns).getChild("position",ns).getAttributeValue("x"));
	int y = scaling * Integer.parseInt(element.getChild("graphics",ns).getChild("position",ns).getAttributeValue("y"));
	setBounds(x-(radius+offset),y-(radius+offset),2*(radius+offset),2*(radius+offset)+textspace);

      addMouseMotionListener(this);
      addMouseListener(this);
    }

    public void paintComponent(Graphics g){
        super.paintComponent(g);
        Graphics2D g2 = (Graphics2D)g;
	  g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
       // Draws the circle.
	  g2.setStroke(new BasicStroke(2.0f));
	 g2.setPaint(Color.white);
	 g2.fill (new Ellipse2D.Double(offset, offset, 2*radius, 2*radius));
	 g2.setPaint(Color.black);
	 g2.draw (new Ellipse2D.Double(offset, offset, 2*radius, 2*radius));
	  // Draws the tokens.
	  String tokenno = element.getChild("initialMarking",ns).getChild("value",ns).getText();
	 g2.drawString(tokenno,radius,radius+offset*2);
	  // Draws the name.
	  String name = element.getChild("name",ns).getChild("value",ns).getText();
	  g2.drawString(name,radius/2,2*(radius+offset*2));

    }


}

