import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;

public class PropertiesFrame extends JInternalFrame {
	Element element;
	Namespace ns;
    static final int xOffset = 400, yOffset = 100;


    public PropertiesFrame(Element e) {
        super("Properties",
              true, //resizable
              true, //closable
              false, //maximizable
              true);//iconifiable);
	  element = e;
	  ns = element.getNamespace();	

        //...Create the GUI and put it in the window...
	  JPanel panel = makePanel();
        Container contentPane = getContentPane();
	  contentPane.add(panel);

        //...Then set the window size or call pack...
        pack();

        //Set the window's location.
        setLocation(xOffset, yOffset);
		
	  String title = element.getName();

	   if (element.getChild("name",ns)!=null)
		if (element.getChild("name",ns).getChild("value",ns)!=null)
			if (element.getChild("name",ns).getChild("value",ns).getText()!="")
			   title += " "+element.getChild("name",ns).getChild("value",ns).getText();
	   if (title.length()>0)
		   setTitle("Properties for: "+title);
    }

	protected JPanel makePanel()  {
		JPanel panel = new JPanel();
		panel.setLayout(new GridLayout(0,2));
		panel.setBorder(BorderFactory.createEmptyBorder(
                                10, //top
                                10, //left
                                10, //bottom
                                10) //right
                                );

		doElement(panel, element, "");

		return panel;
	}

	protected void doAttributes(JPanel panel, Element e, String ancestry) {
		java.util.List attribs = e.getAttributes();
		if (attribs.size()>0) {
			if (ancestry.length()>1)
				ancestry = ancestry+".";
			Iterator as= attribs.iterator();
			while (as.hasNext()) {
				Attribute a = (Attribute) as.next();
				panel.add ( new JLabel("<html><font color='#444444'>"+ancestry+"</font><font color='#000088'><b>"+a.getName()+"</b></font></html>"));
				JTextField field = new JTextField(a.getValue());
				panel.add ( field );
				field.addFocusListener( new AttribUpdater(e,a.getName()) );
				if (a.getName().compareTo("id")==0) {
					field.setEditable(false);
				}
			}
		}
	}
	
	protected void doTextContent(JPanel panel, Element e, String ancestry) {
		String text = e.getTextTrim();
		if (text.length()>0) {
			panel.add ( new JLabel("<html><font color='#444444'><b>"+ancestry+"</b></font></html>") );
			JTextField field = new JTextField(text);
			panel.add ( field );
			field.addFocusListener( new ValueUpdater(e) );
		}
	}

	protected void doElement(JPanel panel, Element e, String ancestry) {
		if (ancestry.length()>0) {
			ancestry += "."+e.getName();
		} else {
			ancestry = " ";
		}
		if (ancestry.startsWith(" .")) {
			ancestry = ancestry.substring(2);
		}

		doTextContent(panel,e,ancestry);
		doAttributes(panel,e,ancestry);

		java.util.List contents = e.getChildren();
		if (contents.size()>0) {
			Iterator cs= contents.iterator();
			while (cs.hasNext()) {
				Element c = (Element) cs.next();
				doElement(panel, c, ancestry);
			}
		}

	}

	public class AttribUpdater implements FocusListener {
		Element element;
		String attrib;
	
		public AttribUpdater(Element e, String att) {
			element = e;
			attrib = att;
		}
	
		public void focusGained(FocusEvent e) { }
	
		public void focusLost(FocusEvent e) {
			if (!e.isTemporary()){
				JTextField field = (JTextField) e.getComponent();	
				element.setAttribute(attrib, field.getText());
			}
		}
	}

	public class ValueUpdater implements FocusListener {
		Element element;
	
		public ValueUpdater(Element e) {
			element = e;
		}
	
		public void focusGained(FocusEvent e) { }
	
		public void focusLost(FocusEvent e) {
			if (!e.isTemporary()){
				JTextField field = (JTextField) e.getComponent();	
				element.setText(field.getText());
			}
		}
	}


}

