import javax.swing.JLabel;
import java.awt.geom.*;
import java.awt.event.*;
import java.awt.image.*; 
import java.awt.*;
import java.util.*;
import org.jdom.*;

public class TransitionLabel extends PetriLabel implements MouseListener, MouseMotionListener{
	int height = 36;
	int width = 16;
	int size;
	int textspace = 15;

    public TransitionLabel(Element e) {
	super(e);

	// set up member variables
	offset = 4;
	xoffset = height-width;
	yoffset = height/2;
	preferredSize = new Dimension(width+offset*2,height+offset*2+textspace);
	// do custom initialisation
	int x = scaling * Integer.parseInt(element.getChild("graphics",ns).getChild("position",ns).getAttributeValue("x"));
	int y = scaling * Integer.parseInt(element.getChild("graphics",ns).getChild("position",ns).getAttributeValue("y"));
	setBounds(x-(height/2+offset),y-(height/2+offset),height+offset*2,height+offset*2+textspace);

      addMouseMotionListener(this);
      addMouseListener(this);

    }

    public void paintComponent(Graphics g){
        super.paintComponent(g);
        Graphics2D g2 = (Graphics2D)g;
	
	  // save original transform settings
	  AffineTransform saveXform = g2.getTransform();
	  // set up this Label's transform
	  AffineTransform at = new AffineTransform();
	  at.scale(scaling, scaling); 
	  at.rotate(Math.toRadians(rotation),offset+(height-width),offset+height/2); 
	  g2.transform(at);

	  g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
       // Draws the rectangle.
	  g2.setStroke(new BasicStroke(2.0f));
	  g2.draw(new Rectangle2D.Double(offset+(height-width)/2,offset, width, height));
	 g2.setPaint(Color.white);
	 g2.fill (new Rectangle2D.Double(offset+(height-width)/2,offset, width, height));
	 g2.setPaint(Color.black);

      	// restore original transform settings
	  g2.setTransform(saveXform);

	  // Draws the name.
	  String name = element.getChild("name",ns).getChild("value",ns).getText();
	  g2.drawString(name,offset*2,height+offset*4);
			
    }


}

